//Copyright (C) 2011, FIE LLC.
//See LICENSE.TXT for details.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace scgui
{
    public class MainClass 
    {
		
		public void Run (List<string> args)
		{
			
			libscclient.Client client;
			libscclient.IPedestalClient pedestal;
			pedestal = libscclient.Client.GetPedestalFromEnvironment();
			client = new libscclient.Client(pedestal);
			client.LoadClientPlugins();
			
			libscclient.IContextClient[] stack = client.GetStack();
			
			if (stack.Count() == 0){
				//no context
				System.Console.WriteLine("Stack is empty.  Can't run scgui client.");
				System.Environment.Exit(-1);
			}
			
			libscclient.IContextClient lastContext = stack[stack.Count() - 1];
			if (!(lastContext is libscclient.ISCUIAppContextClient)){
				//not a scui context
				System.Console.Write("Last context in the stack is no a scui context.");
				System.Environment.Exit(-1);
			}
			
			libscclient.ISCUIAppContextClient scuicontext = (libscclient.ISCUIAppContextClient) lastContext;
			
            //we're already in the context.  We just need to run the gui.
			//bool branching = (scuicontext.GetSettings() as libscclient.SCGUIAppContextSettings).AllowBranching;
            SCGuiWindow scgw = new SCGuiWindow(scuicontext,true,client,pedestal);
			//scgw.Show();
            System.Windows.Forms.Application.Run(scgw);
			//pedestal.RunGUIWindow(scgw.Handle.ToInt64());
			//System.Windows.Forms.Application.Run(scgw);
			//System.Windows.Forms.Application.Run();
            //System.Windows.Forms.Application.Run(scgw);
			//System.Environment.Exit(0);
            return;
		}
		
        //[STAThread]
        public static void Main(string[] args)
        {
			MainClass mc = new MainClass();
			mc.Run(new List<string>(args));
        }



    }
}
